/**
 * project: Mobile Datacommunication
 * file: JMSReceiver.java
 * date: 2003-03-09
 */

package com.maretzke.mobile.jms;

// import JoRAM stuff
import fr.dyade.aaa.joram.admin.*;

// import JMS related classes
import javax.jms.*;

// import naming related classes
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * JoRAMAdmin creates a simple queue. This implementation will use JoRAM - a freeware JMS implementation.
 * <br>
 *
 * @author Michael Maretzke, v-pe
 * @version 1.0
 */
public class JoRAMAdmin {
  public static void main(String [] args) throws Exception {

    System.out.println();
    System.out.println("Start automatic administration of JoRAM JMS Server ...");

    // Getting InitialContext:
    Context ctx = new InitialContext();
            
    // Connecting to JORAM server:
    Admin admin = new Admin("root", "root", 60);

    // Updating the administrator's identity and disconnecting:
    admin.addAdminId("system", "system");
    admin.close();

    // Connecting with the new identity and removing the default one:
    admin = new fr.dyade.aaa.joram.admin.Admin("system", "system", 60);
    admin.delAdminId("root");
    
    // Creating the JMS administered objects:        
    QueueConnectionFactory connFactory = admin.createQueueConnectionFactory();
    Queue queue = admin.createQueue("ConnectionTestQueue");

    // Creating a user (anonymous):
    User user = admin.createUser("anonymous", "anonymous");

    // Setting free access to the queue:
    admin.setFreeReading("ConnectionTestQueue");
    admin.setFreeWriting("ConnectionTestQueue");
            
    // binding all in JNDI
    ctx.rebind("ConnectionTestQueueFactory", connFactory);
    ctx.rebind("ConnectionTestQueue", queue);
            
    ctx.close();
    admin.close();

    System.out.println("Admin closed.");
  }
}
